<?php
/* **************************************************************************** *

 * index.php									*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 All requested html pages are managed by this file. Address requested by web
 browser is changed to http://www.domain.tld/index.php?page=request by .htaccess.
 So index.php is primary script of Albireo for managing HTML output.

 Properties:
    none
 	
 Public Methods:
    this script is procedural
 	
 * **************************************************************************** */

require_once "constants.php"; // requieres Albireo II constants
require_once "autoload.php"; // handle automatic load of classes

header ( "Content-type:text/html; charset=utf-8" );

Localization::session (); // use localization logics

Connection::session () -> logStartOfConnection (); // creates connection log

User::session (); // starts user session

Page::session (); // get information about requested page and check the access

XHTMLPublisher::publish (); // creates xhtml codes
?>