<?php
/**
 * Class for connection analysing. Creates first XML request log.
 * @package    Albireo II
 * @subpackage Kernel
 * @copyright  Copyright (c) 2009 Martin Novák. All rights reserved
 * @license    GNU/AGPL http://www.gnu.org/licenses/agpl.html
 *
 * Albireo is free software! You can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU Affero General Public License for more details.
 */

/**
 * Class for connection analysing. Creates first XML log about a request and
 * provides information about users request
 * @package    Albireo II
 * @subpackage Kernel
 */
class Connection {

    /**
     * @var bool indicates if the request was logged in this server session or not
     */
    private $start_loged = false;
    /**
     * @var object contains instance of Connection (Singleton)
     */
    private static $instance;

    /**
     * Singleton method for calling Connection instance
     * @return object
     */
    public static function session()
    {
        if ( self::$instance == null ) {
    	    self::$instance = new Connection();
    	}
    	return self::$instance;
    }

    private function __clone () {} // private couse of singleton

    private function __construct () {}

    /**
     * Creates a log of particular HTTP request. The method has no return value. It just goes through or die
     * @return bool
     */
    public function logStartOfConnection()
    {
        if ( $this -> start_loged ) { // protects against duplicites
            return;
        }

        $userid = isset ( $_COOKIE [ "spycookie" ] )? $_COOKIE [ "spycookie" ] : time () + rand ();
        setcookie ( "spycookie", $userid );

        Database::connection () -> query ( "INSERT INTO `visitorsstats` (`page`,`hour`,`time`,`year`,`month`,`day`,`ipaddress`,`host`,`useragent`,`httpreferer`,`userid`) VALUES
                ('". addslashes ( preg_replace ( "/(.*?)\?{1}(.*)/", "$1", $_SERVER [ "REQUEST_URI" ] ) ) ."',
                 '". @date ( "H" ) ."',
                 '". @date ( "H:i:s" ) ."',
                 '". @date ( "Y" ) ."',
                 '". @date ( "m" ) ."',
                 '". @date ( "d" ) ."',
                 '". $_SERVER [ "REMOTE_ADDR" ] ."',
                 '". gethostbyaddr ( $_SERVER [ "REMOTE_ADDR" ] ) ."',
                 '". $_SERVER [ "HTTP_USER_AGENT" ] ."',
                 '". @htmlspecialchars ( @$_SERVER [ "HTTP_REFERER" ] ) ."',
                 '". $userid ."');" );
        $this -> start_loged = true;
        return true;
    }
}
?>