<?php
/* **************************************************************************** *

 * Localization.inc.php								*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 This class is used for localization of Albireo and contains settings of
 locale and gettext.
 Gettext is called in source by _() function.

 Properties:
    none
 	
 Public Methods:
    resource session ()		// method for availability of instance
    				   of Singleton
    string getLanguage ()	// gets selected language
    string getFile ( $file, $extension = true )
    				// gets name of page corresponding to $file,
    				   with or without its file extension

 * **************************************************************************** */

class Localization {

    private static $instance;
    private $lang = "cs";

    public static function session ()
    {
    
    	if ( self::$instance == null ) {
    	    self::$instance = new Localization ();
    	}
    	return self::$instance;
    	
    } // end connection

    private function __construct ()
    {
        mb_internal_encoding ( "UTF-8" );
	@date_default_timezone_set ( "Europe/Prague" );
	@putenv ( "LANG=". $this -> lang );
	@setlocale ( LC_ALL, $this -> lang );
	@bindtextdomain ( "languages", realpath ( "locale" ) );
	@textdomain ( "languages" );
	
    } // end __construct

    private function __clone ()
    {
    } // end __clone

    public function getLanguage ()
    {
    	return $this -> lang;
    } // end getLanguage

    public function getFile ( $file, $extension = true )
    {
    	return Database::connection () -> getResult ( "SELECT `file` FROM `header` WHERE `id`=(SELECT `id_header` FROM `scriptpages` WHERE `script`='$file') AND `lang`='". Localization::session () -> getLanguage () ."' LIMIT 1;" ). ( ( $extension ) ? Tools::baseSettings () -> getSetting ( "file_extension" ) : "" );
    } // end getFile

} 
 
?>